#!/bin/sh
############## Merlin2x Initialisation script ##############

USB_FOUND=0

#check for USB 
if [ -e /dev/sda ]
then
	USB_FOUND=1
	if [ -e /dev/sda1 ]
	then
		#mount usb
		cd /home/merlin2
		mkdir usb
		mount /dev/sda1 usb
	else
		#mount usb
		cd /home/merlin2
		mkdir usb
		mount /dev/sda usb
	fi
	
	if [ -e usb/Datavideo/install ]
	then
		usb/Datavideo/install/install.sh
	fi
	
	if [ -e usb/Datavideo/recovery ]
	then
		usb/Datavideo/recovery/recovery.sh
	fi
	
	cd /home/merlin2/software/current
fi

if [ -e zImage ] 
then
	echo "Updating Kernel"
	cp zImage /dev/mmcblk0
	rm zImage
	reboot
fi

#check for fonts
if [ ! -e /home/merlin2/fonts ]
then
	mkdir /home/merlin2/fonts
fi

if [[ -e font32.fnt ]]
then
	mv *.fnt /home/merlin2/fonts
fi

insmod merlin2x_driver.ko

if [ -e /home/merlin2/user_data/mems/network_init.sh ]
then
	/home/merlin2/user_data/mems/network_init.sh
fi

if [ -e ./network_config.sh ]
then
	mv ./network_config.sh /home/merlin2/user_data/mems/
fi

if [ -e /home/merlin2/user_data/mems/network_config.sh ]
then
	/home/merlin2/user_data/mems/network_config.sh
fi

if [ -e /home/merlin2/user_data/mems/default.config ]
then
	rm /var/lib/connman/default.config
	mv /home/merlin2/user_data/mems/default.config /var/lib/connman/default.config
fi

# recover network setting file if not exist or file size < 10
if [ -e /var/lib/connman/default.config ]
then
	fsize=$(stat -c %s /var/lib/connman/default.config)
	if [ $fsize -lt 10 ]
	then
		cp -f default.config /var/lib/connman
	fi
else
	cp -f default.config /var/lib/connman
fi

# if /home/merlin2/user_data/mems/dv000.mem is empty then replace with default file
if [ -s /home/merlin2/user_data/mems/dv000.mem ]; then
	echo -n
else
	cp -f dv000.mem /home/merlin2/user_data/mems/
fi

# check if 50default is not the same, then update it for fallback IP
cmp -s /etc/udhcpc.d/50default 50default
if [ "$?" != "0" ]; then
	cp -f 50default /etc/udhcpc.d/50default
fi

# if dhcp mode then run udhcpc to get IP or fallback IP 192.168.100.30
grep dhcp /var/lib/connman/default.config
if [ "$?" == "0" ]; then
        udhcpc -i eth0 &
fi

# create os_version if not found in ealier multi-partition SD card
if [ ! -e /home/merlin2/config/os_version ]; then
        if [ -e /dev/mmcblk1p7 ]; then
                echo Merlin2 OS v1.0 > /home/merlin2/config/os_version
                sync
        fi
fi

# updat firmware_se3200.bin according to product ID
# SE-3200 uses firmeware_se3200_src.bin
#grep '3.0' /home/merlin2/config/version
#if [ "$?" == "0" ]; then
#	cmp -s firmware_se3200_src.bin firmware_se3200.bin
#	if [ "$?" != "0" ]; then
#		cp -f firmware_se3200_src.bin firmware_se3200.bin
#	fi	
#fi
## HS-3200 uses firmeware_se3200_src.bin
#grep '4.0' /home/merlin2/config/version
#if [ "$?" == "0" ]; then
#	cmp -s firmware_se3200_src.bin firmware_se3200.bin
#	if [ "$?" != "0" ]; then
#		cp -f firmware_se3200_src.bin firmware_se3200.bin
#	fi	
#fi
## SE-2600 uses firmeware_se2600.bin
#grep '3.1' /home/merlin2/config/version
#if [ "$?" == "0" ]; then
#	cmp -s firmware_se2600_src.bin firmware_se3200.bin
#	if [ "$?" != "0" ]; then
#		cp -f firmware_se2600.bin firmware_se3200.bin
#	fi	
#	cmp -s firmware_se2600_src.bin firmware_se2600.bin
#	if [ "$?" != "0" ]; then
#		cp -f firmware_se2600_src.bin firmware_se2600.bin
#	fi	
#fi
## SE-2600MU uses firmeware_se3200_000.bin & remove firmware_se2600.bin to avoid wrong upgrade trouble
#grep '3.2' /home/merlin2/config/version
#if [ "$?" == "0" ]; then
#	cmp -s firmware_se3200_000.bin firmware_se3200.bin
#	if [ "$?" != "0" ]; then
#		cp -f firmware_se3200_000.bin firmware_se3200.bin
#	fi
#	rm firmware_se2600.bin
#fi

sync

#./merlin_streamer &
./merlin2x_processor &

# if version = 4.0 (HS-3200) and boot_delay exist, then
# re-run merlin2x_processor after boot_delay time (0.94),
# try to solve HS-3200 LCD board compatibility issue when boot
grep '4.0' /home/merlin2/config/version
if [ "$?" == "0" ]; then
	if [ -e /home/merlin2/config/boot_delay ]; then
		#sleep 9.4
		cat /home/merlin2/config/boot_delay | awk '{print $1}' | xargs sleep 
		ps | grep ./merlin2x_processor | awk '{print $1}' | xargs kill
		sleep 2
		./merlin2x_processor &
	fi
fi

# add SE-2600 PCM1864/PCM1681 register setting for headphone output
#grep '3.1' /home/merlin2/config/version
#if [ "$?" == "0" ]; then
#	sleep 15
#	# ADC RCA single ended
#	i2cset -y 0 0x4a 0 0 
#	i2cset -y 0 0x4a 8 1
#	i2cset -y 0 0x4a 9 2
#	# DAC headphone enable
#	i2cset -y 0 0x4c 0x0a 0x20
#	i2cset -y 0 0x4c 0x10 0xf3
#	i2cset -y 0 0x4c 0x11 0xf3
#fi

while :
do
	#sleep 10
	# do boot install for USB devices that are mounted slower every sec in 10s
	for i in {1..10}; do
		sleep 1
		if [ $USB_FOUND -eq 0 ]; then
			if [ -e /dev/sda ]; then
				USB_FOUND=1
			
				if [ -e /dev/sda1 ]
				then
					#mount usb
					cd /home/merlin2
					mkdir usb
					mount /dev/sda1 usb
				else
					#mount usb
					cd /home/merlin2
					mkdir usb
					mount /dev/sda usb
				fi

				if [ -e usb/Datavideo/install ] || [ -e usb/Datavideo/recovery ]; then
					# kill running merlin2x_processor
					cat /home/merlin2/config/boot_delay | awk '{print $1}' | xargs sleep 
					ps | grep ./merlin2x_processor | awk '{print $1}' | xargs kill
					
					# do boot install or recovery
					if [ -e usb/Datavideo/install ]; then
						usb/Datavideo/install/install.sh
					fi
					
					if [ -e usb/Datavideo/recovery ]; then
						usb/Datavideo/recovery/recovery.sh
					fi
					
					cd /home/merlin2/software/current
					
					# run merlin2x_processor again
					sleep 2
					./merlin2x_processor &	
				fi
			fi
		fi	
	done

	# break till eth0 available
	ifconfig eth0 | grep 'inet addr:'	
	if [ "$?" == "0" ]; then break; fi
done

grep '4.0' /home/merlin2/config/version
if [ "$?" == "0" ]; then
	python t1-v5_v279.pyc HS-3200 0x05 0x88 0x10 0x02 &
else
	grep '3.1' /home/merlin2/config/version
	if [ "$?" == "0" ]; then
		python t1-v5_v279.pyc SE-2600 0x05 0x88 0x10 0x11 &
	else
		grep '3.2' /home/merlin2/config/version
		if [ "$?" == "0" ]; then
			python t1-v5_v279.pyc SE-2600MU 0x05 0x88 0x10 0x11 &
		else
			python t1-v5_v279.pyc SE-3200 0x05 0x88 0x10 0x02 &
		fi
	fi
fi
